// Code generated by go-swagger; DO NOT EDIT.

package streaming_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewStreamingServiceListDestinationsParams creates a new StreamingServiceListDestinationsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStreamingServiceListDestinationsParams() *StreamingServiceListDestinationsParams {
	return &StreamingServiceListDestinationsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStreamingServiceListDestinationsParamsWithTimeout creates a new StreamingServiceListDestinationsParams object
// with the ability to set a timeout on a request.
func NewStreamingServiceListDestinationsParamsWithTimeout(timeout time.Duration) *StreamingServiceListDestinationsParams {
	return &StreamingServiceListDestinationsParams{
		timeout: timeout,
	}
}

// NewStreamingServiceListDestinationsParamsWithContext creates a new StreamingServiceListDestinationsParams object
// with the ability to set a context for a request.
func NewStreamingServiceListDestinationsParamsWithContext(ctx context.Context) *StreamingServiceListDestinationsParams {
	return &StreamingServiceListDestinationsParams{
		Context: ctx,
	}
}

// NewStreamingServiceListDestinationsParamsWithHTTPClient creates a new StreamingServiceListDestinationsParams object
// with the ability to set a custom HTTPClient for a request.
func NewStreamingServiceListDestinationsParamsWithHTTPClient(client *http.Client) *StreamingServiceListDestinationsParams {
	return &StreamingServiceListDestinationsParams{
		HTTPClient: client,
	}
}

/*
StreamingServiceListDestinationsParams contains all the parameters to send to the API endpoint

	for the streaming service list destinations operation.

	Typically these are written to a http.Request.
*/
type StreamingServiceListDestinationsParams struct {

	// OrganizationID.
	OrganizationID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the streaming service list destinations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StreamingServiceListDestinationsParams) WithDefaults() *StreamingServiceListDestinationsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the streaming service list destinations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StreamingServiceListDestinationsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the streaming service list destinations params
func (o *StreamingServiceListDestinationsParams) WithTimeout(timeout time.Duration) *StreamingServiceListDestinationsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the streaming service list destinations params
func (o *StreamingServiceListDestinationsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the streaming service list destinations params
func (o *StreamingServiceListDestinationsParams) WithContext(ctx context.Context) *StreamingServiceListDestinationsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the streaming service list destinations params
func (o *StreamingServiceListDestinationsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the streaming service list destinations params
func (o *StreamingServiceListDestinationsParams) WithHTTPClient(client *http.Client) *StreamingServiceListDestinationsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the streaming service list destinations params
func (o *StreamingServiceListDestinationsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithOrganizationID adds the organizationID to the streaming service list destinations params
func (o *StreamingServiceListDestinationsParams) WithOrganizationID(organizationID string) *StreamingServiceListDestinationsParams {
	o.SetOrganizationID(organizationID)
	return o
}

// SetOrganizationID adds the organizationId to the streaming service list destinations params
func (o *StreamingServiceListDestinationsParams) SetOrganizationID(organizationID string) {
	o.OrganizationID = organizationID
}

// WriteToRequest writes these params to a swagger request
func (o *StreamingServiceListDestinationsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param organization_id
	if err := r.SetPathParam("organization_id", o.OrganizationID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
