// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// LogService20210330CreateDestinationRequest log service 20210330 create destination request
//
// swagger:model log_service_20210330CreateDestinationRequest
type LogService20210330CreateDestinationRequest struct {

	// cloudwatch logs provider
	CloudwatchLogsProvider *LogService20210330StreamingCloudwatchLogsProvider `json:"cloudwatch_logs_provider,omitempty"`

	// datadog provider
	DatadogProvider *LogService20210330StreamingDatadogProvider `json:"datadog_provider,omitempty"`

	// destination_name is a human readable name for the destination.
	DestinationName string `json:"destination_name,omitempty"`

	// organization id
	OrganizationID string `json:"organization_id,omitempty"`

	// source_channel denotes where the create request was made from. For example terraform or the hcp ui.
	SourceChannel string `json:"source_channel,omitempty"`

	// splunk cloud provider
	SplunkCloudProvider *LogService20210330StreamingSplunkCloudProvider `json:"splunk_cloud_provider,omitempty"`
}

// Validate validates this log service 20210330 create destination request
func (m *LogService20210330CreateDestinationRequest) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCloudwatchLogsProvider(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDatadogProvider(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSplunkCloudProvider(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *LogService20210330CreateDestinationRequest) validateCloudwatchLogsProvider(formats strfmt.Registry) error {
	if swag.IsZero(m.CloudwatchLogsProvider) { // not required
		return nil
	}

	if m.CloudwatchLogsProvider != nil {
		if err := m.CloudwatchLogsProvider.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cloudwatch_logs_provider")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("cloudwatch_logs_provider")
			}
			return err
		}
	}

	return nil
}

func (m *LogService20210330CreateDestinationRequest) validateDatadogProvider(formats strfmt.Registry) error {
	if swag.IsZero(m.DatadogProvider) { // not required
		return nil
	}

	if m.DatadogProvider != nil {
		if err := m.DatadogProvider.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("datadog_provider")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("datadog_provider")
			}
			return err
		}
	}

	return nil
}

func (m *LogService20210330CreateDestinationRequest) validateSplunkCloudProvider(formats strfmt.Registry) error {
	if swag.IsZero(m.SplunkCloudProvider) { // not required
		return nil
	}

	if m.SplunkCloudProvider != nil {
		if err := m.SplunkCloudProvider.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("splunk_cloud_provider")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("splunk_cloud_provider")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this log service 20210330 create destination request based on the context it is used
func (m *LogService20210330CreateDestinationRequest) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateCloudwatchLogsProvider(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateDatadogProvider(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSplunkCloudProvider(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *LogService20210330CreateDestinationRequest) contextValidateCloudwatchLogsProvider(ctx context.Context, formats strfmt.Registry) error {

	if m.CloudwatchLogsProvider != nil {

		if swag.IsZero(m.CloudwatchLogsProvider) { // not required
			return nil
		}

		if err := m.CloudwatchLogsProvider.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("cloudwatch_logs_provider")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("cloudwatch_logs_provider")
			}
			return err
		}
	}

	return nil
}

func (m *LogService20210330CreateDestinationRequest) contextValidateDatadogProvider(ctx context.Context, formats strfmt.Registry) error {

	if m.DatadogProvider != nil {

		if swag.IsZero(m.DatadogProvider) { // not required
			return nil
		}

		if err := m.DatadogProvider.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("datadog_provider")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("datadog_provider")
			}
			return err
		}
	}

	return nil
}

func (m *LogService20210330CreateDestinationRequest) contextValidateSplunkCloudProvider(ctx context.Context, formats strfmt.Registry) error {

	if m.SplunkCloudProvider != nil {

		if swag.IsZero(m.SplunkCloudProvider) { // not required
			return nil
		}

		if err := m.SplunkCloudProvider.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("splunk_cloud_provider")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("splunk_cloud_provider")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *LogService20210330CreateDestinationRequest) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *LogService20210330CreateDestinationRequest) UnmarshalBinary(b []byte) error {
	var res LogService20210330CreateDestinationRequest
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
