// Code generated by go-swagger; DO NOT EDIT.

package integration_subscription_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateIntegrationSubscriptionParams creates a new CreateIntegrationSubscriptionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateIntegrationSubscriptionParams() *CreateIntegrationSubscriptionParams {
	return &CreateIntegrationSubscriptionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateIntegrationSubscriptionParamsWithTimeout creates a new CreateIntegrationSubscriptionParams object
// with the ability to set a timeout on a request.
func NewCreateIntegrationSubscriptionParamsWithTimeout(timeout time.Duration) *CreateIntegrationSubscriptionParams {
	return &CreateIntegrationSubscriptionParams{
		timeout: timeout,
	}
}

// NewCreateIntegrationSubscriptionParamsWithContext creates a new CreateIntegrationSubscriptionParams object
// with the ability to set a context for a request.
func NewCreateIntegrationSubscriptionParamsWithContext(ctx context.Context) *CreateIntegrationSubscriptionParams {
	return &CreateIntegrationSubscriptionParams{
		Context: ctx,
	}
}

// NewCreateIntegrationSubscriptionParamsWithHTTPClient creates a new CreateIntegrationSubscriptionParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateIntegrationSubscriptionParamsWithHTTPClient(client *http.Client) *CreateIntegrationSubscriptionParams {
	return &CreateIntegrationSubscriptionParams{
		HTTPClient: client,
	}
}

/*
CreateIntegrationSubscriptionParams contains all the parameters to send to the API endpoint

	for the create integration subscription operation.

	Typically these are written to a http.Request.
*/
type CreateIntegrationSubscriptionParams struct {

	// Body.
	Body CreateIntegrationSubscriptionBody

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create integration subscription params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateIntegrationSubscriptionParams) WithDefaults() *CreateIntegrationSubscriptionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create integration subscription params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateIntegrationSubscriptionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create integration subscription params
func (o *CreateIntegrationSubscriptionParams) WithTimeout(timeout time.Duration) *CreateIntegrationSubscriptionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create integration subscription params
func (o *CreateIntegrationSubscriptionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create integration subscription params
func (o *CreateIntegrationSubscriptionParams) WithContext(ctx context.Context) *CreateIntegrationSubscriptionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create integration subscription params
func (o *CreateIntegrationSubscriptionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create integration subscription params
func (o *CreateIntegrationSubscriptionParams) WithHTTPClient(client *http.Client) *CreateIntegrationSubscriptionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create integration subscription params
func (o *CreateIntegrationSubscriptionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create integration subscription params
func (o *CreateIntegrationSubscriptionParams) WithBody(body CreateIntegrationSubscriptionBody) *CreateIntegrationSubscriptionParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create integration subscription params
func (o *CreateIntegrationSubscriptionParams) SetBody(body CreateIntegrationSubscriptionBody) {
	o.Body = body
}

// WithLocationProjectID adds the locationProjectID to the create integration subscription params
func (o *CreateIntegrationSubscriptionParams) WithLocationProjectID(locationProjectID string) *CreateIntegrationSubscriptionParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the create integration subscription params
func (o *CreateIntegrationSubscriptionParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WriteToRequest writes these params to a swagger request
func (o *CreateIntegrationSubscriptionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
