// Code generated by go-swagger; DO NOT EDIT.

package integration_subscription_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewUpdateIntegrationSubscriptionParams creates a new UpdateIntegrationSubscriptionParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateIntegrationSubscriptionParams() *UpdateIntegrationSubscriptionParams {
	return &UpdateIntegrationSubscriptionParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateIntegrationSubscriptionParamsWithTimeout creates a new UpdateIntegrationSubscriptionParams object
// with the ability to set a timeout on a request.
func NewUpdateIntegrationSubscriptionParamsWithTimeout(timeout time.Duration) *UpdateIntegrationSubscriptionParams {
	return &UpdateIntegrationSubscriptionParams{
		timeout: timeout,
	}
}

// NewUpdateIntegrationSubscriptionParamsWithContext creates a new UpdateIntegrationSubscriptionParams object
// with the ability to set a context for a request.
func NewUpdateIntegrationSubscriptionParamsWithContext(ctx context.Context) *UpdateIntegrationSubscriptionParams {
	return &UpdateIntegrationSubscriptionParams{
		Context: ctx,
	}
}

// NewUpdateIntegrationSubscriptionParamsWithHTTPClient creates a new UpdateIntegrationSubscriptionParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateIntegrationSubscriptionParamsWithHTTPClient(client *http.Client) *UpdateIntegrationSubscriptionParams {
	return &UpdateIntegrationSubscriptionParams{
		HTTPClient: client,
	}
}

/*
UpdateIntegrationSubscriptionParams contains all the parameters to send to the API endpoint

	for the update integration subscription operation.

	Typically these are written to a http.Request.
*/
type UpdateIntegrationSubscriptionParams struct {

	// Body.
	Body UpdateIntegrationSubscriptionBody

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update integration subscription params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateIntegrationSubscriptionParams) WithDefaults() *UpdateIntegrationSubscriptionParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update integration subscription params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateIntegrationSubscriptionParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update integration subscription params
func (o *UpdateIntegrationSubscriptionParams) WithTimeout(timeout time.Duration) *UpdateIntegrationSubscriptionParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update integration subscription params
func (o *UpdateIntegrationSubscriptionParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update integration subscription params
func (o *UpdateIntegrationSubscriptionParams) WithContext(ctx context.Context) *UpdateIntegrationSubscriptionParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update integration subscription params
func (o *UpdateIntegrationSubscriptionParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update integration subscription params
func (o *UpdateIntegrationSubscriptionParams) WithHTTPClient(client *http.Client) *UpdateIntegrationSubscriptionParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update integration subscription params
func (o *UpdateIntegrationSubscriptionParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update integration subscription params
func (o *UpdateIntegrationSubscriptionParams) WithBody(body UpdateIntegrationSubscriptionBody) *UpdateIntegrationSubscriptionParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update integration subscription params
func (o *UpdateIntegrationSubscriptionParams) SetBody(body UpdateIntegrationSubscriptionBody) {
	o.Body = body
}

// WithLocationProjectID adds the locationProjectID to the update integration subscription params
func (o *UpdateIntegrationSubscriptionParams) WithLocationProjectID(locationProjectID string) *UpdateIntegrationSubscriptionParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the update integration subscription params
func (o *UpdateIntegrationSubscriptionParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateIntegrationSubscriptionParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
