// Code generated by go-swagger; DO NOT EDIT.

package tenant_service

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCreateTenantParams creates a new CreateTenantParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateTenantParams() *CreateTenantParams {
	return &CreateTenantParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateTenantParamsWithTimeout creates a new CreateTenantParams object
// with the ability to set a timeout on a request.
func NewCreateTenantParamsWithTimeout(timeout time.Duration) *CreateTenantParams {
	return &CreateTenantParams{
		timeout: timeout,
	}
}

// NewCreateTenantParamsWithContext creates a new CreateTenantParams object
// with the ability to set a context for a request.
func NewCreateTenantParamsWithContext(ctx context.Context) *CreateTenantParams {
	return &CreateTenantParams{
		Context: ctx,
	}
}

// NewCreateTenantParamsWithHTTPClient creates a new CreateTenantParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateTenantParamsWithHTTPClient(client *http.Client) *CreateTenantParams {
	return &CreateTenantParams{
		HTTPClient: client,
	}
}

/*
CreateTenantParams contains all the parameters to send to the API endpoint

	for the create tenant operation.

	Typically these are written to a http.Request.
*/
type CreateTenantParams struct {

	// Body.
	Body CreateTenantBody

	/* LocationProjectID.

	   project_id is the projects id.
	*/
	LocationProjectID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create tenant params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateTenantParams) WithDefaults() *CreateTenantParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create tenant params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateTenantParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create tenant params
func (o *CreateTenantParams) WithTimeout(timeout time.Duration) *CreateTenantParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create tenant params
func (o *CreateTenantParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create tenant params
func (o *CreateTenantParams) WithContext(ctx context.Context) *CreateTenantParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create tenant params
func (o *CreateTenantParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create tenant params
func (o *CreateTenantParams) WithHTTPClient(client *http.Client) *CreateTenantParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create tenant params
func (o *CreateTenantParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create tenant params
func (o *CreateTenantParams) WithBody(body CreateTenantBody) *CreateTenantParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create tenant params
func (o *CreateTenantParams) SetBody(body CreateTenantBody) {
	o.Body = body
}

// WithLocationProjectID adds the locationProjectID to the create tenant params
func (o *CreateTenantParams) WithLocationProjectID(locationProjectID string) *CreateTenantParams {
	o.SetLocationProjectID(locationProjectID)
	return o
}

// SetLocationProjectID adds the locationProjectId to the create tenant params
func (o *CreateTenantParams) SetLocationProjectID(locationProjectID string) {
	o.LocationProjectID = locationProjectID
}

// WriteToRequest writes these params to a swagger request
func (o *CreateTenantParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.Body); err != nil {
		return err
	}

	// path param location.project_id
	if err := r.SetPathParam("location.project_id", o.LocationProjectID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
